/**************** -*- mode: java -*- ***************************

The contents of this file are subject to the Mozilla Public
License Version 1.1 (the "License"); you may not use this file
except in compliance with the License. You may obtain a copy of
the License at http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS
IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
implied. See the License for the specific language governing
rights and limitations under the License.

The Original Code is Aphrodite Development Team code.

The Initial Developer of the Original Code is Aphrodite
Development Team.  Portions created by Aphrodite
Development Team are Copyright (C) 1999-2001
Aphrodite Development Team.
All Rights Reserved.

Contributor(s): 
                       Mark Anderson 
                       David Boswell 
                       Jeff Campbell 
                       Pete Collins 
                       Lorenzo De Tomasi 
                       Neil Deakin 
                       John Dobbins 
                       Klein Duijmpje 
                       Ben Goodger 
                       Julia Kleyman 
                       Lemming 
                       Aaron Leventhal 
                       Jason LoBrutto 
                       Anders Lund 
                       Petrus Lundqvist 
                       Brian Mathis 
                       Yusuf Motara 
                       Chris Nelson 
                       Robert O'Connor 
                       Isriya Paireepairit 
                       Dan Ridley 
                       Richard Shaw 
                       Tekhir 
                       Matthew Thomas 
                       Waldo 

**********************************************************/

const ahpOK=true;

/**************** Globals ***********************/


var win;
var bundle              = srGetStrBundle("chrome://navigator/locale/navigator.properties");
var pref                = null;
var appCore             = null;
var startPageDefault    = "about:blank";
var startTime           = 0;
var explicitURL         = false; 
var defaultStatus       = bundle.GetStringFromName( "defaultStatus" );
var jsStatus            = null;
var jsDefaultStatus     = null;
var overLink            = null;
var statusTextFld       = null;
var throbberElement     = null;
var stopMenu            = null;
var stopButton          = null;
var locationFld         = null;
var backButton          = null;
var forwardButton       = null;
var backButtonMenu      = null;
var forwardButtonMenu   = null;
var parentChrome        = "chrome://aphrodite/content/aphrodite.xul";
var homePageDefault     = bundle.GetStringFromName( "homePageDefault" );
var textZoom            = 1.0;
var gDisableBookmarks   = false;
var statusMeter         = null;
var openLink            = null;
var useRealProgressFlag = false;
var retrieved_actions	= 0;
var url_entry			= new Array();
var url_protocol		= new Array();
var url_host			= new Array();
var url_string			= new Array();
var actions				= document.getElementById('urlbar_search');

try {

        pref = Components.classes['@mozilla.org/preferences;1'];
        pref = pref.getService();
        pref = pref.QueryInterface(Components.interfaces.nsIPref);
}

catch (ex) {

        dump("failed to get prefs service!\n");
        pref = null;
}

/***************** Globals **********************/


function createBrowserInstance() {
    dump("  createBrowserInstance()\n");
    var AppCore   = new Components.Constructor('@mozilla.org/appshell/component/browser/instance;1', 'nsIBrowserInstance');
    appCore       = new AppCore();

    dump('appcore = '+appCore);

    //for(list in appCore)
    //dump(list+'\n');

    if ( !appCore ){
    alert( "Error creating browser instance\n" );
    return;

    }

    dump("\n\n**** APHRODITE ****\n\n");

  }


/**************** UpdateHistory *******************/

function UpdateHistory(event)
{
    // This is registered as a capturing "load" event handler. When a
    // document load completes in the content window, we'll be
    // notified here. This allows us to update the global history and
    // set the document's title information.
   //  dump("UpdateHistory: content's location is '" + window._content.location.href + "',\n");
    //dump("                         title is '" + window._content.document.title + "'\n");
        if ((window._content.location.href) && (window._content.location.href != ""))
        {
                try
                {
                        var history = Components.classes["@mozilla.org/browser/global-history;1"].getService();
                        if (history) history = history.QueryInterface(Components.interfaces.nsIGlobalHistory);
                        if (history) history.SetPageTitle(window._content.location.href, window._content.document.title);
                }
                catch (ex)
                {
                        dump("failed to set the page title.\n");
                }
        }
}    



/**************** UpdateHistory ***********************/

/**************** UpdateStatusField *******************/

function UpdateStatusField() {

        var text = defaultStatus;

        if(jsStatus)
                text = jsStatus;

        else if(overLink)
                text = overLink;

        else if(jsDefaultStatus)
                text = jsDefaultStatus;

        if(!statusTextFld)
        	var StatusTextFld = document.getElementById("statusText");

        StatusTextFld.setAttribute("value", text);
}

/**************** UpdateStatusField *******************/


/**************** nsXULBrowserWindow *******************/

function nsXULBrowserWindow() { }

nsXULBrowserWindow.prototype =
{
    QueryInterface : function(iid)
        {
        if(iid.equals(Components.interfaces.nsIXULBrowserWindow))
        return this;
        throw Components.results.NS_NOINTERFACE;
				return false;
        },
    setJSStatus : function(status)
        {
        if(status == "")
            jsStatus = null;
        else
            jsStatus = status;
        UpdateStatusField();
        },
    setJSDefaultStatus : function(status)
        {
        if(status == "")
            jsDefaultStatus = null;
        else
            jsDefaultStatus = status;
        UpdateStatusField();
        },
    setDefaultStatus : function(status)
        {
        if(status == "")
            defaultStatus = null;
        else
            defaultStatus = status;
        UpdateStatusField();
        },
    setOverLink : function(link)
        {
        if(link == "")
            overLink = null;
        else
            overLink = link;
        UpdateStatusField();
        },
  onProgress : function (channel, current, max)
  {
   if(!statusMeter)
     statusMeter = document.getElementById("statusbar-icon");
    var percentage = 0;

    // ins anders 10/18/2000:
    if (!useRealProgressFlag && (channel != null)) {
      return;
    }

    if (max > 0)
    {
      percentage = (current * 100) / max ;
      if (statusMeter.getAttribute(G_MODE) != G_NORMAL)
      statusMeter.setAttribute(G_MODE, G_NORMAL);
      statusMeter.value = percentage;
      statusMeter.progresstext = Math.round(percentage) + "%";
    }
    else {
      if (statusMeter.getAttribute(G_MODE) != "undetermined")
        statusMeter.setAttribute(G_MODE,"undetermined");
    }
  },
  onStateChange : function(channel, state)
  {
      if(!throbberElement)
        throbberElement = document.getElementById("Throbber");
      if(!statusMeter)
        statusMeter = document.getElementById("statusbar-icon");
      if(!stopButton)
        stopButton = document.getElementById("stop-button");
      if(!stopMenu)
        stopMenu = document.getElementById("menuitem-stop");

      if (state & Components.interfaces.nsIWebProgressListener.STATE_START) {
        if(state & Components.interfaces.nsIWebProgressListener.STATE_IS_NETWORK) {
          // Remember when loading commenced.
          startTime = (new Date()).getTime();
          // Turn progress meter on.
          statusMeter.setAttribute(G_MODE,"undetermined");
          throbberElement.setAttribute(G_BUSY, true);

          // XXX: These need to be based on window activity...
          stopButton.setAttribute("disabled", false);
          stopMenu.setAttribute("disabled", false);

	  // let user know we started
	  defaultStatus = "Requesting document: " + channel.name;
	  UpdateStatusField();

          // Initialize the progress stuff...
          statusMeter.setAttribute(G_MODE,"undetermined");
          useRealProgressFlag = false;
          totalRequests = 0;
          var finishedRequests = 0;
        }
        if (state & Components.interfaces.nsIWebProgressListener.STATE_IS_REQUEST) {
					var totalRequests="";
          totalRequests += 1;
        }
      }
      else if (state & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
        if (state & Components.interfaces.nsIWebProgressListener.STATE_IS_REQUEST) {
          finishedRequests += 1;
          if (!useRealProgressFlag) {
            this.onProgress(null, finishedRequests, totalRequests);
          }
        }
        if(state & Components.interfaces.nsIWebProgressListener.STATE_IS_NETWORK) {
          // Record page loading time.
          var elapsed = ( (new Date()).getTime() - startTime ) / 1000;
          var msg = bundle.GetStringFromName("nv_done");
          msg = msg.replace(/%elapsed%/, elapsed);
          defaultStatus = msg;
          UpdateStatusField();
          //window.XULBrowserWindow.setDefaultStatus(msg);
          //this.setDefaultStatus(msg);
          this.setOverLink(msg);
          // Turn progress meter off.
          statusMeter.setAttribute(G_MODE,G_NORMAL);
          statusMeter.value = 0;  // be sure to clear the progress bar
          statusMeter.progresstext = "";
          throbberElement.removeAttribute(G_BUSY);

          // XXX: These need to be based on window activity...
          stopButton.setAttribute("disabled", true);
          stopMenu.setAttribute("disabled", true);

          writeCrashFile();

        }
      }
      else if (state & Components.interfaces.nsIWebProgressListener.STATE_TRANSFERRING) {
         // tell user how far we have come
	 if (totalRequests > 1) {
	    // BAD - hardcoded string!
	    var thisReq = finishedRequests + 1;
	    defaultStatus = "Retrieving " + thisReq + "/" + totalRequests + " elements";
	    UpdateStatusField();
        }
        if (state & Components.interfaces.nsIWebProgressListener.STATE_IS_DOCUMENT) {
          var ctype=channel.contentType;

          if (ctype != "text/html") {
            useRealProgressFlag = true;
          }
          statusMeter.setAttribute(G_MODE, G_NORMAL);
        }
        if (state & Components.interfaces.nsIWebProgressListener.STATE_IS_REQUEST) {
          if (!useRealProgressFlag) {
            this.onProgress(null, finishedRequests, totalRequests);
          }
        }
      }

    },
    onLocationChange : function(location)
        {
        if(!locationFld)
        locationFld = document.getElementById("urlbar");

        locationFld.setAttribute("value", location);
        UpdateBackForwardButtons();

	defaultStatus = "Loading document: " + location;
	UpdateStatusField();

        },

  onStatus : function(channel, status, msg)
  {
    this.setOverLink(msg);
    //this.setDefaultStatus(msg);
  }


}

/**************** nsXULBrowserWindow *******************/


/**************** UpdateBackForwardButtons *******************/

function UpdateBackForwardButtons() {

        if(!backButton)
        backButton = document.getElementById("canGoBack");
  if (!backButtonMenu)
  backButtonMenu = document.getElementById("canGoBackMult");

        if(!forwardButton)
        forwardButton = document.getElementById("canGoForward");
  if (!forwardButtonMenu)
  forwardButtonMenu = document.getElementById("canGoForwardMult");

        backButton.setAttribute("disabled", !parent.appCore.canGoBack);
        forwardButton.setAttribute("disabled", !parent.appCore.canGoForward);
        backButtonMenu.setAttribute("disabled", !parent.appCore.canGoBack);
        forwardButtonMenu.setAttribute("disabled", !parent.appCore.canGoForward);

}      

/**************** UpdateBackForwardButtons *******************/

/*************************** START UP **********************************/

function Startup() {

    //dump('calling Startup on aphrodite.js **** \n\n');
    //set the appshell on the parent
    parent.Startup();
    parent.window.XULBrowserWindow  = new nsXULBrowserWindow();

    window.XULBrowserWindow         = new nsXULBrowserWindow();
    win = document.getElementById( "main-window" );

    if(!parent.appCore)
    createBrowserInstance();

    if (parent.appCore == null) {
    dump("\n\n**** giving up ****\n\n");
    window.close();
    }

    //if(parent.appCore)
    //parent.appCore.setWebShellWindow(window);

    tryToSetContentWindow();
    var contentArea = document.getElementById("content");

    if (contentArea){
    contentArea.addEventListener("load", UpdateHistory, true);
    contentArea.addEventListener("load", UpdateBookmarksLastVisitedDate, true);
    contentArea.addEventListener("load", UpdateInternetSearchResults, true);
    }
    //dump("*** Pulling out the charset\n");
    if ( window.arguments && window.arguments[1] ) {
        if (window.arguments[1].indexOf('charset=') != -1) {
              arrayArgComponents = window.arguments[1].split('=');
            if (arrayArgComponents) {
                if (appCore != null) {
                 //we should "inherit" the charset menu setting in a new window
                  appCore.SetDocumentCharset(arrayArgComponents[1]);
                }
                //dump("*** SetDocumentCharset(" + arrayArgComponents[1] + ")\n");
            }
        }
    }

    try
    {
    	var searchMode = pref.GetIntPref("browser.search.mode");
    	setBrowserSearchMode(searchMode);
    }
    catch(ex)
    {
    }
	 // Check for window.arguments[0].  If present, go to that url.
    // changed to look in parent.args, which seems to work... -anders
    if ( parent.arguments && parent.arguments[0] ) {
        // Load it using yet another psuedo-onload handler.
        onLoadViaOpenDialog();
    }
    //if (window.arguments && window.arguments[0])
    //onLoadViaOpenDialog();

    crashRecovery();
    //dump('calling Startup on aphrodite.js **** END \n\n');

}  


/*************************** START UP **********************************/

/*************************** BOOKMARKS *********************************/

function UpdateBookmarksLastVisitedDate(event)
{
    if ((window._content.location.href) && (window._content.location.href != ""))
    {
        try{

      var wnd = document.commandDispatcher.focusedWindow;

      if (window == wnd) wnd = window._content;
      var docCharset = wnd.document.characterSet;

        // if the URL is bookmarked, update its "Last Visited" date
        var bmks = Components.classes["@mozilla.org/browser/bookmarks-service;1"].getService();
        if (bmks)   bmks = bmks.QueryInterface(Components.interfaces.nsIBookmarksService);
        if (bmks)   bmks.UpdateBookmarkLastVisitedDate(window._content.location.href, docCharset);
        }

        catch(ex) { dump("failed to update bookmark last visited date.\n"); }
    }
}

/*************************** BOOKMARKS *********************************/

function onLoadWithArgs() {

    // See if Startup has been run.
    if ( parent.appCore ) {
        // See if load in progress (loading default page).
        if ( document.getElementById("Browser:Throbber").getAttribute(G_BUSY) == "true" ) {
            dump( "Stopping load of default initial page\n" );
            parent.appCore.stop();
        }
        dump( "Loading page specified on ShowWindowWithArgs\n" );
        parent.appCore.loadInitialPage();
    } else {
        // onLoad handler timing is not correct yet.
        dump( "onLoadWithArgs not needed yet\n" );
        // Remember that we want this url.
        explicitURL = true;
    }
}  




/**************************** Load URL *********************************/

function BrowserLoadURL() {

        dump("****************** LOADING ********************\n\n");

        if (parent.appCore == null) { dump("BrowserAppCore has not been initialized\n"); return; }

        var bar         = document.getElementById('urlbar');
        var url         = bar.value;

        switch(url) {

        case "about:mozilla":
        url                             = "chrome://aphrodite/content/html/mozilla.html";
        parent.appCore.loadUrl( url );
        bar.value                       = "about:mozilla";
        break;

        case "about:alphanumerica":
        url                             = "http://www.alphanumerica.com/about/";
        parent.appCore.loadUrl( url );
        bar.value                       = "about:alphanumerica";
        break;

        default :
	  /**
	   * this would leave us w/ a lot of possible errors!
	   * Instead, just try the search services if the url starts w/ "?".
	  if (p_type[0] == "http" || p_type[0] == "ftp" || p_type[0] == "https")
	    {        
	    parent.appCore.loadUrl( url );
          return;
	    }
	   */
	  if (url.match(/^\s*\?/))  // assume search service if first non-space is a "?".
	    {
	    // theese aren't needed until here!
            var p_type	        = url.split(":"); // is the arg to split a regex?
	                                          // in perl I would do split /\s*:\s*/;
	    //var p_slice 	= url.slice(0, 1); - i dumped that one!
	    var index_array;
	    var re		= /%query%/i; //NOTE "%"
	    var querystring;
	    if (retrieved_actions == "0")
              get_url_actions()
            // get the real service name.
            var service = p_type[0];
            service = service.replace(/^\s*\?/,''); // remove leading "?" including spaces leading that.
            service = service.replace(/^\s*(.+)/, "$1"); // trim left
            service = service.replace(/(\S)\s*$/, "$1"); // trim right
	    // get the service index
	    index_array = check_match(service);
	    // if the service dosen't exixt, complaint and back out!
	    if (index_array >= url_entry.length) {
	       alert("Service '" + service + "' is not defined");
	       return;
	    }
	    var query = p_type[1];
            query = query.replace(/^\s*(.+)/, "$1"); // trim - Is there some string.trimBlanks in js?
            query = query.replace(/(\S)\s*$/, "$1"); // trim

	    dump("Search action: trimmed query: '" + query + "'\n");
	       
	    querystring = url_string[index_array].replace(re, escape(query)); // uri escape query
	    querystring = querystring.replace(/%\^amp\^%/g, "&"); // Oops, RS forgot this one -
	                                                         // better off in get_url_actions
								 // where it would be done once, but
								 // in my opinion get_url_actions shouldn't
								 // be there.
								 // Btw, beeing a XML format, rdf may like the well
								 // known "&amp;" entity??
	    url = url_protocol[index_array] + "://" + url_host[index_array] + "/" +querystring;
	       
	    dump("Search action: URL to use: " + url + "\n");
	    dump("Search action: Unscaped URL: " + unescape(url) + "\n");
	    }  
	    	    
        parent.appCore.loadUrl( url );
        //return;
        }
   window._content.focus(); // if we got all the way, some resource is loading, so allow the user to scroll!!!
        
}         

/**************************** Load URL *********************************/

/**************************** GET URLBAR ACTIONS ***********************/
function get_url_actions()
{
var ii = 0;
while (ii < document.getElementById('urlbar_search').childNodes.length)
  {
  url_entry[ii]		= document.getElementById('urlbar_search').childNodes.item(ii).getAttribute("s_entry");  
  url_protocol[ii]	= document.getElementById('urlbar_search').childNodes.item(ii).getAttribute("s_protocol");
  url_host[ii]		= document.getElementById('urlbar_search').childNodes.item(ii).getAttribute("s_host");  
  url_string[ii]		= document.getElementById('urlbar_search').childNodes.item(ii).getAttribute("s_string");    
  ii++;
  }
retrieved_actions = 1;
}
/**************************** GET URLBAR ACTIONS ***********************/

/**************************** CHECK FOR MATCH **************************/

/* ----------- DEPRICATED, SEE BELOW ----------------------
function check_match(entry)
{
var i = 0;
     entry = entry.replace(/^\s{0,}\?/,''); // remove leading "?" including spaces leading that.
   entry = entry.replace(/^\s{0,}(.+)\s{0,}$/, "$1"); // trim
while(i < url_entry.length)
  {
     dump(entry + " / " +  url_entry[i] + "\n");
  if(entry ==  url_entry[i])
    {
    break;//return i; //I changed the style here more to my liking, see below
    }
    //else
    //{
    i++;
    //}
  }
   dump("matching service: " + i + "\n");
  return i;
} 
 ----------------------------------------------  */
// get the index of a service from its name
// badly named function, how about get_service_by_name() ?
function check_match(entry)
{
  var i = 0;
  //var reg;
  while(i < url_entry.length) {
    //reg = "/^" + url_entry[i] + "$/i";
    if(entry == url_entry[i])   //.match(reg)) // there's something wacke w/ javascript match()
      break; //got it!
    i++;
  }
  return i;
} 
/**************************** CHECK FOR MATCH **************************/

/**************************** SET CONTENT WINDOW ***********************/

function tryToSetContentWindow(){

var startpage = startPageDefault;

//preLoadImages();

if ( window._content ) {
        parent.appCore.setContentWindow( window._content );

        if ( !explicitURL ) {
            // if all else fails, use trusty "about:blank" as the start page
            if (pref) {
              // from mozilla/modules/libpref/src/init/all.js
              // 0 = blank
              // 1 = home (browser.Startup.homepage)
              // 2 = last

                var choice = 1;
                try {
                        choice = pref.getLocalizedUnicharPref("browser.startup.homepage");//pref.GetIntPref("browser.startup.page");
                }
                catch (ex) {
                        dump("failed to get the browser.startup.page pref\n");
                }
                //dump("browser.startup.page = " + choice + "\n");

          switch (choice) {

                case 0:
                                startpage = "about:alphanumerica";
                                break;
                case 1:
                                try {
                                        startpage = pref.CopyCharPref("browser.startup.homepage");
                                }
                                catch (ex) {
                                        dump("failed to get the homepage!\n");
                                        startpage = startPageDefault;
                                }
                                break;
                case 2:
                                var history = Components.classes['@mozilla.org/browser/global-history;1'];
                        if (history) {
                                        history = history.getService();
                        }
                        if (history) {
                                        history = history.QueryInterface(Components.interfaces.nsIGlobalHistory);
                        }
                        if (history) {
                                startpage = history.GetLastPageVisted();
                        }
                                break;
                default:
                                startpage = choice;//startPageDefault;
          }

}
            else { dump("failed to QI pref service\n"); }

          var args = document.getElementById("args")
          if (args) args.setAttribute("value", startpage);

        }

        if(parent.openLink){
        startpage           = parent.openLink;
        parent.openLink     = null;
        }

        if(parent.switchURL){
        startpage           = parent.switchURL;
        parent.switchURL    = null;
        }
        parent.appCore.loadInitialPage();

    }

        else {

        // Try again.
        dump("Scheduling later attempt to set content window\n");
        window.setTimeout( "tryToSetContentWindow()", 100 );
    }

}

/**************************** SET CONTENT WINDOW *********/


/**************************** BACK ***********************/

 function BrowserBack() {

        var bb                          = document.getElementById("canGoBack");

        if ( (bb.getAttribute("disabled")) == "true" )
        return;

        if (parent.appCore != null) {
        UpdateBackForwardButtons(); // anders
        dump("******** Going Back ********\n");
        parent.appCore.back();
        }       

        else { dump("BrowserAppCore has not been created!\n"); }
  }

/**************************** BACK ***********************/

/**************************** FORWARD ********************/

  function BrowserForward() {


     var fb = document.getElementById("canGoForward");

     if ( (fb.getAttribute("disabled")) == "true" )

        return;

    if (parent.appCore != null) {

      dump("******** Going Forward ********\n");
      UpdateBackForwardButtons(); //anders

      parent.appCore.forward();

    } else {

      dump("BrowserAppCore has not been created!\n");
    }
  }
        
/**************************** FORWARD **********************/

/**************************** RELOAD ***********************/

 function BrowserReallyReload(reloadType) {

     // Get a handle to the "canReload" broadcast id

     var reloadBElem = document.getElementById("canReload");

     if (!reloadBElem) {

        dump("Couldn't obtain handle to reload Broadcast element\n");
        return;

           }

     var canreload = reloadBElem.getAttribute("disabled");

     // If the reload button is currently disabled, just return

     if ( canreload) { return; }

     //Call in to BrowserAppcore to reload the current loading

     if (parent.appCore != null) {

        dump("******** Going to reload ********\n");
        parent.appCore.reload(reloadType);

     } 

        else { dump("BrowserAppCore has not been created!\n"); }

  }
                

/**************************** RELOAD ***********************/

/**************************** CAN STOP *********************/

function BrowserCanStop() {

    var stop = document.getElementById("canStop");
    if ( stop ) {
        var stopDisabled = stop.getAttribute("disabled");
        var stopButton   = document.getElementById( "stop-button" );
        if ( stopButton ) {
            if ( stopDisabled == "true") {
                stopButton.setAttribute( "disabled", "true" );
            } else {
                stopButton.setAttribute( "disabled", "" );
            }
        }
        //Enable/disable the stop menu item
        var stopMenu   = document.getElementById( "menuitem-stop" );
        if ( stopMenu ) {
            if ( stopDisabled == "true") {
                stopMenu.setAttribute( "disabled", "true" );
            } else {
                stopMenu.setAttribute( "disabled", "" );
            }
        }
    }
  }  

/**************************** CAN STOP *******************/

/**************************** STOP ***********************/

 function BrowserStop() {

     // Get a handle to the "canStop" broadcast id

     var stopBElem = document.getElementById("canStop");

     if (!stopBElem) {
        dump("Couldn't obtain handle to stop Broadcast element\n");
        return;
           }

     var canStop = stopBElem.getAttribute("disabled");
     var sb = document.getElementById("stop-button");

     if (!sb) {
         dump("Could not obtain handle to stop button\n");
             return;
     }
     // If the stop button is currently disabled, just return

     if ((sb.getAttribute("disabled")) == "true") {
            return;
     }

     //Stop button has just been pressed. Disable it.
     sb.setAttribute("disabled", "true");
     // Get a handle to the stop menu item.

     var sm = document.getElementById("menuitem-stop");

     if (!sm) {
       dump("Couldn't obtain menu item Stop\n");
     } else {
       // Disable the stop menu-item.
       sm.setAttribute("disabled", "true");
     }
     //Call in to BrowserAppcore to stop the current loading

     if (parent.appCore != null) {

        dump("Going to Stop\n");

        parent.appCore.stop();

     } else {

        dump("BrowserAppCore has not been created!\n");
     }
  }
   
/**************************** STOP ***********************/

/**************************** HOME ***********************/

function BrowserHome() {

   window._content.home();
   RefreshUrlbar();

}

/**************************** HOME ***********************/

/**************************** REFRESH URLBAR  ************/

function RefreshUrlbar() {

        // commenting out right now i don't see whaqt this does

    //document.getElementById('urlbar').value = window._content.location.href;
        return;

  } 

/**************************** REFRESH URLBAR  *************/

/**************************** PRINT ***********************/

function BrowserPrint() {

     var printBElem = document.getElementById("canPrint");

     if (!printBElem) {

        dump("Couldn't obtain handle to reload Broadcast element\n");
        return;

           }

        //var canreload = reloadBElem.getAttribute("disabled");
        //pb                    = document.getElementById( "print" );

        if ( (printBElem.getAttribute("disabled")) == "true" )
        return;

        if (parent.appCore != null) { parent.appCore.print(); }

}   

/**************************** PRINT ***********************/


/**************************** SCREEN **********************/

function getEnvironment(){

        screenWidth             = parseInt( screen.width );
        screenHeight            = parseInt( screen.height );
        winWidth                = Math.round(eval( parseFloat(screenWidth/1.5) ) );
        winHeight               = Math.round(eval( parseFloat(screenHeight/1.5) ) );
        return;

}

/**************************** SCREEN ***********************/


/**************************** SET WIN SIZE *****************/

function setWinSize(){
        dump("**** setting window size to "+winWidth+" X "+winHeight+" ****\n");
        window.resizeTo( winWidth, winHeight );
        //window.resizeTo( 640, 480 );
        return;
}

/**************************** SET WIN SIZE ***********************/


/**************************** MOVE WINDOW ***********************/

function moveWindow(){

        var x = win.getAttribute( "x" );
        var y = win.getAttribute( "y" );
        dump(" move to "+x+" "+y+"\n");
        window.moveTo( 0, 0 );
        return;
        window.moveTo( x, y );
        return;
}

/**************************** MOVE WINDOW ***********************/

/**************************** FIND ******************************/

function BrowserFind() {

        if (parent.appCore != null) { parent.appCore.find(); }

        else { dump("BrowserAppCore has not been created!\n"); }
  }

/**************************** FIND ******************************/

/**************************** STATUS ****************************/

function onStatus( tip, ID ) {

        var toolTip     = document.getElementById(ID);
    if(!toolTip)
    return;

        if( tip ){

        toolTip.setAttribute( "value", tip );

        toolTip.setAttribute( "arrow", true );

        }

        else{

        toolTip.setAttribute( "value", "" );

        toolTip.removeAttribute( "arrow" );

        }
}

/**************************** STATUS ****************************/

/**************************** MENUS *****************************/

/**************************** MENUS *****************************/
 


/***************** Command Updater functions *****************/


function goUpdateCommand(command){

        var controller = top.document.commandDispatcher.getControllerForCommand(command);
        
        var enabled = false;
        
        if (controller)
        enabled = controller.isCommandEnabled(command);
                
        goSetCommandEnabled(command, enabled);
}

function goDoCommand(command) {

        var controller = top.document.commandDispatcher.getControllerForCommand(command);

        if (controller)
        controller.doCommand(command);
}


function goSetCommandEnabled(id, enabled) {

        var node = document.getElementById(id);

        if (node)
        {
        if (enabled)
        node.removeAttribute("disabled");
        else
        node.setAttribute('disabled', 'true');
        }
}

function goSetMenuValue(command, valueAttribute) {

        var commandNode = top.document.getElementById(command);

        if (commandNode){
        var value = commandNode.getAttribute(valueAttribute);
        if (value)
        commandNode.setAttribute('value', value);
        }
}


function goOnEvent(node, event){

    var numControllers = node.controllers.getControllerCount();
    var controller;
    for ( var controllerIndex = 0; controllerIndex < numControllers; controllerIndex++ )
    {
        controller = node.controllers.getControllerAt(controllerIndex);
        if ( controller )
            controller.onEvent(event);
    }
}

function goUpdateGlobalEditMenuItems() {
        goUpdateCommand('cmd_undo');
        goUpdateCommand('cmd_redo');
        goUpdateCommand('cmd_cut');
        goUpdateCommand('cmd_copy');
        goUpdateCommand('cmd_paste');
        goUpdateCommand('cmd_pasteQuote');
        goUpdateCommand('cmd_selectAll');
        goUpdateCommand('cmd_delete');
}


function goUpdateSelectEditMenuItems(){
        goUpdateCommand('cmd_cut');
        goUpdateCommand('cmd_copy');
        goUpdateCommand('cmd_delete');
}


function goUpdateUndoEditMenuItems(){

        goUpdateCommand('cmd_undo');
        goUpdateCommand('cmd_redo');

        // we shouldn't really do this here, but we don't get the right notifications now
        goUpdateCommand('cmd_paste');
        goUpdateCommand('cmd_pasteQuote');
}

/***************** Command Updater functions *****************/


/***************** openBrowserWindow  *****************/

function openBrowserWindow() {

    if(openLink)
    openLink    = null;

    var Pref    = new Components.Constructor("@mozilla.org/preferences;1", "nsIPref");
    pref        = new Pref();
		var choice;

    var startpage = "about:blank";

    if (pref) {

      choice = 1;
      try { choice = pref.GetIntPref("browser.startup.page"); }

      catch (ex) { dump("failed to get the browser.startup.page pref\n"); }

    switch (choice) {

      case 0:
        startpage               = "about:blank";
        break;

      case 1:
        try { startpage         = pref.CopyCharPref("browser.startup.homepage"); }

        catch (ex) {
        dump("failed to get the browser.startup.homepage pref\n");
        startpage               = "about:blank";

        }
      break;

      case 2:
        try {
                var history     = Components.classes["@mozilla.org/browser/global-history;1"].getService();
                history         = history.QueryInterface(Components.interfaces.nsIGlobalHistory);
                startpage       = history.GetLastPageVisted();
        }

        catch (ex) { dump(ex +"\n"); }
      break;

      default:
                startpage       = "about:blank";
    }

  }
        dump("\n\n********************"+startpage+"\n\n");
        window.openDialog( parentChrome, "_blank", "chrome,all,dialog=no", startpage );
}

/***************** openBrowserWindow  *****************/


/**************************** VIEW SOURCE ****************************/

function BrowserViewSource(){
window.openDialog( "chrome://navigator/content/viewSource.xul", "_blank", "chrome,dialog=no", window._content.location);
}

/**************************** VIEW SOURCE ****************************/


/**************************** QUIT **********************************/

function goQuitApplication() {

  var windowManager = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService();
  var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
  var enumerator = windowManagerInterface.getEnumerator( null );

  while ( enumerator.hasMoreElements()  )
  {
    var  windowToClose = enumerator.getNext();
    var domWindow = windowManagerInterface.convertISupportsToDOMWindow( windowToClose );
    domWindow.focus();
    if ( domWindow.tryToClose == null )
    {
      domWindow.close();
    }
    else
    {
      if ( !domWindow.tryToClose() )
        return false;
    }
  };

  var appShell = Components.classes['@mozilla.org/appshell/appShellService;1'].getService();
  appShell = appShell.QueryInterface( Components.interfaces.nsIAppShellService );
  appShell.Quit();
  return true;

}



/**************************** QUIT **********************************/

/*************************** CLOSE ****************************/
/** I added this function for ease/clarity,
    because aphrodite segfaulted at close (on linux).
    See Shutdown()
*/
function browserClose() {
   window.close();
}
/*************************** CLOSE ****************************/


/**************************** onLoadViaOpenDialog **********************************/

function onLoadViaOpenDialog() {
		      //dump("In onLoadViaOpenDialog()\n");
    // See if load in progress (loading default page).
    if ( document.getElementById("Throbber").getAttribute(G_BUSY) == "true" ) 
		{
        dump( "Stopping load of default initial page\n" );
        parent.appCore.stop();
    }
    //dump( "Loading page specified via openDialog\n" );
    //dump("Check if a view source window \n");
    	if( window.arguments && window.arguments[1]=="view-source" )
    	{
        dump(" A view source window \n");
        var element = document.getElementById("main-window");
        var preface = element.getAttribute("viewsourcetitlepreface");
        element.setAttribute( "titlepreface", preface );
        parent.appCore.isViewSource = true;
        element.setAttribute("windowtype","Browser:view-source");
    	}
    parent.appCore.loadUrl( parent.arguments[0] );
  }

/**************************** onLoadViaOpenDialog **********************************/

/**************************** ShowWindowFromResource **********************************/

function ShowWindowFromResource( node ) {

        var winManager = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService();
        dump("got window Manager \n");
        var     winManagerInterface = winManager.QueryInterface( Components.interfaces.nsIWindowMediator);
    dump("got interface \n");
    var desiredWindow = null;
    var url = node.getAttribute('id');
    dump( url +" finding \n" );
        desiredWindow = winManagerInterface.getWindowForResource( url );
        dump( "got window \n");
        if ( desiredWindow )
        {
                dump("focusing \n");
                desiredWindow.focus();
        }
}   

/**************************** ShowWindowFromResource **********************************/


/******************** onProgress ************************/

function onProgress() {

    var throbber = document.getElementById("Browser:Throbber");
    var meter    = document.getElementById("Browser:LoadingProgress");

    if ( throbber && meter ) {

        var busy = eval( throbber.getAttribute(G_BUSY) );
        var wasBusy = meter.getAttribute(G_MODE) == "undetermined" ? true : false;

        if(busy) {

        if ( !wasBusy ) {
        startTime = (new Date()).getTime();
        meter.setAttribute(G_MODE, "undetermined");
        }

        } 

        else {

        meter.setAttribute(G_MODE, G_NORMAL);
        var elapsed     = ( (new Date()).getTime() - startTime ) / 1000;
        var msg         = bundle.GetStringFromName("nv_done") + " (" + elapsed + " secs)";
        defaultStatus   = msg;
        UpdateStatusField();
        window.XULBrowserWindow.setDefaultStatus(msg);

        }
            }
        }

/******************** onProgress ************************/


/******************* toMessengerWindow ******************/

function toMessengerWindow(){

    try{
        var layoutType = pref.GetIntPref("mail.pane_config");

        if(layoutType == 0)
            toOpenWindowByType("mail:3pane", "chrome://messenger/content/messenger.xul");
        else
            toOpenWindowByType("mail:3pane", "chrome://messenger/content/mail3PaneWindowVertLayout.xul");
    }

    catch(ex){ toOpenWindowByType("mail:3pane", "chrome://messenger/content/messenger.xul"); }
}

/******************* toMessengerWindow ******************/

/******************* toAddressBook ******************/

function toAddressBook() { toOpenWindowByType("mail:addressbook", "chrome://messenger/content/addressbook/addressbook.xul"); }

/******************* toAddressBook ******************/

/******************* toNewsgroups ******************/

function toNewsgroups() { dump ("Sorry, command not implemented.\n"); }

/******************* toNewsgroups ******************/


/******************* toOpenWindowByType ******************/

function toOpenWindowByType( inType, uri ) {

        var winManager = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService();
        var winManagerInterface = winManager.QueryInterface( Components.interfaces.nsIWindowMediator);
        var topWindow = winManagerInterface.getMostRecentWindow( inType );
        if ( topWindow )
                topWindow.focus();
        else
                window.open(uri, "_blank", "chrome,menubar,toolbar,resizable");
}

/******************* toOpenWindowByType ******************/


/*******************  toComposer ******************/

function toComposer() { cycleWindow('composer:html', 'chrome://editor/content/editor.xul'); }

/*******************  toComposer ******************/

/*******************  cycleWindow ******************/

function cycleWindow( inType, inChromeURL ){

    var windowManager = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService();
    dump("got window Manager \n");
    var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator);
    dump("got interface \n");

    var desiredWindow = null;

    var topWindowOfType = windowManagerInterface.getMostRecentWindow( inType );
    var topWindow = windowManagerInterface.getMostRecentWindow( null );
    dump( "got windows \n");

    dump( "topWindowOfType = " + topWindowOfType + "\n");
    if ( topWindowOfType == null )
    {
      if ( inType == "navigator:browser" )
      OpenBrowserWindow();
    else if ( inType == "composer:html" ) /* open editor window */
      NewEditorWindow();
    else
    {
        /* what to do here? */
    }

        return;
    }

    if ( topWindowOfType != topWindow )
    {
        dump( "first not top so give focus \n");
        topWindowOfType.focus();
        return;
    }

    var enumerator = windowManagerInterface.getEnumerator( inType );
    firstWindow = windowManagerInterface.convertISupportsToDOMWindow ( enumerator.getNext() );
    if ( firstWindow == topWindowOfType )
    {
        dump( "top most window is first window \n");
        firstWindow = null;
    }
    else
    {
        dump("find topmost window \n");
        while ( enumerator.hasMoreElements() )
        {
            var nextWindow = windowManagerInterface.convertISupportsToDOMWindow ( enumerator.getNext() );
            if ( nextWindow == topWindowOfType )
                break;
        }
    }
    desiredWindow = firstWindow;
    if ( enumerator.hasMoreElements() )
    {
        dump( "Give focus to next window in the list \n");
        desiredWindow = windowManagerInterface.convertISupportsToDOMWindow ( enumerator.getNext() );
    }

    if ( desiredWindow )
    {
        desiredWindow.focus();
        dump("focusing window \n");
    }
    else
    {
        dump("open window \n");
      if ( inType == "navigator:browser" )
      window.OpenBrowserWindow();
    else if ( inType == "composer:html" ) /* open editor window */
      NewEditorWindow();
    else
    {
        /* what to do here? */
    }
    }
}

/*******************  cycleWindow ******************/

/*******************  NewEditorWindow ******************/

function NewEditorWindow() {

  dump("In NewEditorWindow()...\n");
  // Open editor window with blank page
  // Kludge to leverage openDialog non-modal!
  window.openDialog( "chrome://editor/content", "_blank", "chrome,all,dialog=no", "about:blank");
}

/*******************  NewEditorWindow ******************/

/******************* goPreferences  ******************/

function goPreferences(id, paneURL, paneID){

  var prefWindowModalityPref;

  try {

    var pref = Components.classes["@mozilla.org/preferences;1"].getService();
    if( pref )
      pref = pref.QueryInterface( Components.interfaces.nsIPref );
    if( pref )
      prefWindowModalityPref = pref.GetBoolPref( "browser.prefWindowModal");
  }

  catch(e) { prefWindowModalityPref = true; }

  var modality = prefWindowModalityPref ? "yes" : "no";
  var prefWindow = window.openDialog("chrome://communicator/content/pref/pref.xul","PrefWindow", "chrome,modal=" + modality+
",resizable=yes", paneURL, paneID);

}

/******************* goPreferences  ******************/


/******************* OpenBookmarkURL  ******************/

function OpenBookmarkURL(node, datasources) {

if (node.getAttribute('container') == "true") { return false; }

var url = node.getAttribute('id');

    try
		{
      // add support for IE favorites under Win32, and NetPositive URLs under BeOS
      var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService();
      if (rdf)   
				rdf = rdf.QueryInterface(Components.interfaces.nsIRDFService);
      if (rdf && datasources)
      {
      	var src = rdf.GetResource(url, true);
        var prop = rdf.GetResource("http://home.netscape.com/NC-rdf#URL", true);
        var target = datasources.GetTarget(src, prop, true);
        if(target)     
					target = target.QueryInterface(Components.interfaces.nsIRDFLiteral);
        if(target)     
					target = target.Value;
        if(target)     
					url = target;
        }
    }

    catch (err) { dump(err+"\n"); }

    // Ignore "NC:" urls.
    if (url.substring(0, 3) == "NC:")
      return false;

		var retval;
    // Check if we have a browser window
    if (window._content == null)
   	 retval=window.openDialog( "chrome://aphrodite/content/aphrodite.xul", "_blank", "chrome,all,dialog=no", url );
		 

    else 
		{
        window._content.location.href = url;
        RefreshUrlbar();
				retval=ahpOK;
     }

	return retval;

}

/******************* OpenBookmarkURL  ******************/


/******************* goOpenNewMessage  ******************/

function goOpenNewMessage()
{
        var msgComposeService = Components.classes["@mozilla.org/messengercompose/compose;1"].getService();
        msgComposeService = msgComposeService.QueryInterface(Components.interfaces.nsIMsgComposeService);
        msgComposeService.OpenComposeWindow(null, null, Components.interfaces.nsIMsgCompType.New, Components.interfaces.nsIMsgCompFormat.Default, null);

}

/******************* goOpenNewMessage  ******************/


/******************* openLocation  ******************/

function openLocation() {

    window.openDialog( "chrome://navigator/content/openLocation.xul", "_blank", "chrome,modal", parent.appCore );

}

/******************* openLocation  ******************/


/******************* editPage  ******************/

function editPage(url){ window.openDialog( "chrome://editor/content", "_blank", "chrome,all,dialog=no", url ); }

/******************* editPage  ******************/

/******************* savePage  ******************/

function savePage( url ) {

        if ( !url ) { url = window._content.location.href; }
        var xfer = Components.classes[ "@mozilla.org/appshell/component/xfer;1" ].getService( Components.interfaces.nsIStreamTransfer );

  try {
          var postData = parent.appCore.postData;
    xfer.SelectFileAndTransferLocationSpec( url, window, "", "", true, postData);
        }
        catch( exception ) { dump( "SelectFileAndTransferLocationSpec failed, rv=" + exception + "\n" ); }
}

/******************* savePage  ******************/

/******************* UpdateInternetSearchResults  ******************/

function UpdateInternetSearchResults(event)
{
        if ((window._content.location.href) && (window._content.location.href != ""))
        {
                var     searchInProgressFlag = false;
                try
                {
                var search = Components.classes["@mozilla.org/rdf/datasource;1?name=internetsearch"].getService();
                if (search)     search = search.QueryInterface(Components.interfaces.nsIInternetSearchService);
                if (search)     searchInProgressFlag = search.FindInternetSearchResults(window._content.location.href);
                }
                catch(ex) { }

                if (searchInProgressFlag == true) { RevealSearchPanel(); }
        }
}

/******************* UpdateInternetSearchResults  ******************/


/******************* BrowserAddBookmark  ******************/

 function BrowserAddBookmark(url,title){

    var bmks = Components.classes["@mozilla.org/browser/bookmarks-service;1"].getService();
    var wnd = document.commandDispatcher.focusedWindow;

    if (window == wnd) wnd = window._content;

    var docCharset = wnd.document.characterSet;

    bmks = bmks.QueryInterface(Components.interfaces.nsIBookmarksService);

    if ((title == null) || (title == ""))
    title = url;

    bmks.AddBookmark(url, title, bmks.BOOKMARK_DEFAULT_TYPE, docCharset);
    dump("BrowserAddBookmark: " + docCharset + "\n");

  }

/******************* BrowserAddBookmark  ******************/


/******************* enableBookmarks  ******************/

function enableBookmarks() { gDisableBookmarks = false; }

/******************* enableBookmarks  ******************/


/******************* BrowserEditBookmarks  ******************/

function BrowserEditBookmarks(){

  var cwindowManager = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService();
  var iwindowManager = Components.interfaces.nsIWindowMediator;
  var windowManager  = cwindowManager.QueryInterface(iwindowManager);
  var bookmarksWindow = windowManager.getMostRecentWindow('bookmarks:manager');

  if (bookmarksWindow) {
    bookmarksWindow.focus();
  }

    else {
    if (true == gDisableBookmarks) {
    return;
    }

    gDisableBookmarks = true;
    window.open("chrome://communicator/content/bookmarks/bookmarks.xul", "_blank", "chrome,menubar,resizable,scrollbars");
    setTimeout(enableBookmarks, 2000);

  }

}


/******************* BrowserEditBookmarks ******************/

function Shutdown(){

        try{

                // If bookmarks are dirty, flush 'em to disk
                var bmks = Components.classes["@mozilla.org/browser/bookmarks-service;1"].getService();
                if (bmks)       bmks = bmks.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
                if (bmks)       bmks.Flush();
        }

        catch (ex) { }

        try{

                // give history a change at flushing to disk also
                var history = getService( "@mozilla.org/browser/global-history;1", "nsIRDFRemoteDataSource" );
                if (history)
                history.Flush();
        }

        catch (ex) { }
  // added this to avoid segfault! (anders)
  if (parent.appCore)
    parent.appCore.close();
}

/******************** OPEN NEW WINDOW WITH *****************/

function openNewWindowWith( url ) {

    openLink                = url;
    var newWin              = window.openDialog( parentChrome, "_blank", "chrome,all,dialog=no", url );
    newWin.saveFileAndPos   = true;

}

/******************** OPEN NEW WINDOW WITH *****************/

/******************** GO MENU STUFF ************************/

function gotoHistoryIndex( aEvent )
  {
      var index = aEvent.target.getAttribute("index");
      if(index)
      {
        dump(index);
        parent.appCore.gotoHistoryIndex(index);
        return true;
      }
      else
      {
          var id = aEvent.target.getAttribute("id");
          dump(id);

          if (id == "menuitem-back")
          	BrowserBack();

          else 

						if (id == "menuitem-forward")
          		BrowserForward();
      }
	return ahpOK;
	
  }
  

/******************** GO MENU STUFF ************************/

/******************** TOOLTIPS *****************************/

function setNavButtonTooltip(aDirection)
  {
    // Get the content area docshell
    var browserElement = document.getElementById("content");
    if (browserElement)
      {
        var docShell = browserElement.boxObject.QueryInterface(Components.interfaces.nsIBrowserBoxObject).docShell;
        if (docShell)
          {
            var webNavigation = docShell.QueryInterface(Components.interfaces.nsIWebNavigation);
            if (webNavigation)
              {
                var shistory = webNavigation.sessionHistory;
                if (shistory)
                  {
                    var index = shistory.index;
                    var bindex, desperatTitle;
                    if (aDirection == 'back') {
                      bindex = index - 1;
                      desperatTitle = "Go Back";
                    } else {
                      bindex = index + 1;
                      desperatTitle = "Go Ahead";
                    }
                    // back button
                    var b = document.getElementById(aDirection + "-button");
                    var entry;
                    try { entry = shistory.getEntryAtIndex(bindex, false); }
       catch (e) {/* this sometimes gives "uncaught ex.."*/ }
                    if (entry) {
                      var title = null;
                      title = entry.title;
                      if(!title) {
      // I know, this is mush..
      var host = entry.URI.host || 'file://';
      title = host + "/" + entry.URI.path;
          }
                      if(!title) title = desperatTitle;
                      b.setAttribute("tooltiptext", title);
                    }
                 }
              }
          }
      }
  }





/************** Handle middle click *********************/

  function browserHandleMiddleClick(event)
  {
    var target = event.target;
    if (pref.GetBoolPref("middlemouse.openNewWindow"))
    {
      var node = enclosingLink(target);
      var href ="";
      if (node)
        href = node.href;
      if (href != "")
      {
  // save if shift is down (should I ask for a pref ? - how ?)
  if (event.shiftKey) {
    savePage(href);
  } else {
          openNewWindowWith(href);
  }
        event.preventBubble();
        return;
      }
    }
/* * * * // We may wan't to work on this later...
    if (pref.GetBoolPref("middlemouse.paste"))
    {
      if (isScrollbar(target)) {
         return;
    }
      var tagName = target.tagName;
      if (tagName) tagName = tagName.toLowerCase();
      var type = target.type;
      if (type) type = type.toLowerCase();

      var url = readFromClipboard();
      //dump ("Loading URL on clipboard: '" + url + "'; length = " + url.length + "\n");
      if (url.length > 0)
      {
        var urlBar = document.getElementById("urlbar");
        urlBar.value = url;
        BrowserLoadURL();
        event.preventBubble();
      }
    }
* * * * */
  }

/********************* handle middle click ***********/


  function enclosingLink(node)
  {
    while (node)
    {
      var nodeName = node.nodeName;
      if (nodeName == "")
        return null;
      nodeName = nodeName.toLowerCase();
      if (nodeName == "" || nodeName == "body"
          || nodeName == "html" || nodeName == "#document")
        return null;
      var href = node.href;
      if (nodeName == "a" && href != "")
        return node;
      node = node.parentNode;
    }
    return null;
  }

/******************** PRELOADIMAGES ************************/

function preLoadImages(){

dump('preloading images\n\n');

var img1        = new Image();
img1.src        = 'chrome://aphrodite/skin/default/images/toolbar/back-button-hover.gif';

var img2        = new Image();
img2.src        = 'chrome://aphrodite/skin/default/images/toolbar/back-button-active.gif';

var img3        = new Image();
img3.src        = 'chrome://aphrodite/skin/default/images/toolbar/forward-button-hover.gif';

var img4        = new Image();
img4.src        = 'chrome://aphrodite/skin/default/images/toolbar/forward-button-active.gif';

var img5        = new Image();
img5.src        = 'chrome://aphrodite/skin/default/images/toolbar/stop-button-hover.gif';

var img6        = new Image();
img6.src        = 'chrome://aphrodite/skin/default/images/toolbar/stop-button-active.gif';

var img7        = new Image();
img7.src        = 'chrome://aphrodite/skin/default/images/toolbar/reload-button-hover.gif';

var img8        = new Image();
img8.src        = 'chrome://aphrodite/skin/default/images/toolbar/reload-button-active.gif';

var img9        = new Image();
img9.src        = 'chrome://aphrodite/skin/default/images/toolbar/toolbar-grippy-hover.png';

var img10       = new Image();
img10.src       = 'chrome://aphrodite/skin/default/images/toolbar/home-hover.gif';

var img11       = new Image();
img11.src       = 'chrome://aphrodite/skin/default/images/toolbar/home-active.gif';

var img12       = new Image();
img12.src       = 'chrome://aphrodite/skin/default/images/toolbar/go-hover.gif';

var img13       = new Image();
img13.src       = 'chrome://aphrodite/skin/default/images/toolbar/go-active.gif';

var img14       = new Image();
img14.src       = 'chrome://aphrodite/skin/default/images/toolbar/print-hover.gif';

var img15       = new Image();
img15.src       = 'chrome://aphrodite/skin/default/images/toolbar/print-active.gif';

var img16       = new Image();
img16.src       = 'chrome://aphrodite/skin/default/images/toolbar/security-hover.gif';

var img17       = new Image();
img17.src       = 'chrome://aphrodite/skin/default/images/toolbar/security-active.gif';

var img18       = new Image();
img18.src       = 'chrome://aphrodite/skin/default/images/toolbar/find-hover.gif';

var img19       = new Image();
img19.src       = 'chrome://aphrodite/skin/default/images/toolbar/find-active.gif';

var img20       = new Image();
img20.src       = 'chrome://aphrodite/skin/default/images/toolbar/functionbar-left-grippy-hv.gif';

var img21       = new Image();
img21.src       = 'chrome://aphrodite/skin/default/images/toolbar/functionbar-right-grippy-hv.gif';

var img22       = new Image();
img22.src       = 'chrome://aphrodite/skin/default/images/toolbar/fb-lft-grippy-closed-hv.gif';

var img23       = new Image();
img23.src       = 'chrome://aphrodite/skin/default/images/toolbar/fb-rt-grippy-closed-hv.gif';

}

/******************** PRELOADIMAGES ************************/


/****************** toHistory *********************/
// open the history window, code from communicator.

// bad hack from communicator.
// avoid opening, if in process.
var gDisableHistory = false;
function enableHistory() {
  gDisableHistory = false;
}
function toHistory()
{
  // Use a single sidebar history dialog

  var cwindowManager = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService();
  var iwindowManager = Components.interfaces.nsIWindowMediator;
  var windowManager  = cwindowManager.QueryInterface(iwindowManager);

  var historyWindow = windowManager.getMostRecentWindow('history:manager');

  if (historyWindow) {
    //debug("Reuse existing history window");
    historyWindow.focus();
  } else {
    //debug("Open a new history dialog");

    if (true == gDisableHistory) {
      //debug("Recently opened one. Wait a little bit.");
      return;
    }
    gDisableHistory = true;

    window.open( "chrome://communicator/content/history/history.xul", "_blank", "chrome,menubar,resizable,scrollbars" );
    setTimeout(enableHistory, 2000);
  }

}
/****************** toHistory *********************/

/* ************* Functions for preferences ********* */

/********* getPrefService ***********/

function getPrefService () {
  return Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPref);
}

/********* getPrefService ***********/

/******** toggleBoolPref *******/

function toggleBoolPref(name) {
    var prefs = getPrefService();
    prefs.SetBoolPref(name, !prefs.GetBoolPref(name));
    prefs.SavePrefFile();
}

/******** toggleBoolPref *******/

/******** getBoolPref *******/

function getBoolPref(name) {
  var prefs = getPrefService();
  return prefs.GetBoolPref(name);
}

/******** getBoolPref *******/

/******** getIntPref *******/
function getIntPref(name) {
  var p = getPrefService();
  return p.GetIntPref(name);
}
/******** getIntPref *******/

/******** setIntPref *******/
function setIntPref(name, value) {
  var p = getPrefService();
  p.SetIntPref(name, value);
  p.SavePrefFile();
}
/******** setIntPref *******/

/*********** setRadioMenuGr *************/

/******** updatePrefMenu *******/
/* Called when view->preferences menu is created,
 * to make sure the state is syncronized
 */
function updatePrefMenu() {

  document.getElementById('allow-js').setAttribute('checked', getBoolPref('javascript.enabled'));
  document.getElementById('allow-java').setAttribute('checked', getBoolPref('security.enable_java'));
  document.getElementById('warn-cookies').setAttribute('checked', getBoolPref('network.cookie.warnAboutCookies'));

  var imgAry = ['all-images','site-images','no-images'];
  document.getElementById(imgAry[getIntPref('network.image.imageBehavior')]).setAttribute('checked', true);

  var cooAry = ['all-cookies','site-cookies','no-cookies'];
  document.getElementById(cooAry[getIntPref('network.cookie.cookieBehavior')]).setAttribute('checked', true);
}
/******** updatePrefMenu *******/

/* ************* END Functions for preferences ********* */


/* ************* Assecories : open tool windows ******** */

function toJSConsole()
{
  toOpenWindowByType("global:console", "chrome://global/content/console.xul");
}

function toJavaConsole()
{
  try{
    var cid =
      Components.classes['@mozilla.org/oji/jvm-mgr;1'];
    var iid = Components.interfaces.nsIJVMManager;
    var jvmMgr = cid.getService(iid);
    jvmMgr.ShowJavaConsole();
  } catch(e) {

  }
}


/*************** Assecories : open tool windows ************/

/******************* Create back / forwards menus *************/

/**************************** BACK-MENU ***********************/
function BrowserBackMenu(event)
  {
         var bb= document.getElementById("canGoBackMult");

    if ( (bb.getAttribute("disabled")) == "true" )
        return;
    //FillHistoryMenu(event.target, "back");
    parent.appCore.backButtonPopup(event.target);
  }
/**************************** BACK-MENU ***********************/

/**************************** FORWARD-MENU ***********************/
function BrowserForwardMenu(event)
  {
         var bb= document.getElementById("canGoForwardMult");

    if ( (bb.getAttribute("disabled")) == "true" )
        return;
    parent.appCore.forwardButtonPopup(event.target);
  }
/**************************** FORWARD-MENU ***********************/
/******************* END Create back / forwards menus *************/
