/*
   Tooltip functions
   Clipped from widget-toolkit/global/content/globalOverlay.js
*/

//dump("tooltip.js loaded\n");

function setTooltipText(aID, aTooltipText)
{
  var element = document.getElementById(aID);
  if (element)
    element.setAttribute("tooltiptext", aTooltipText);
}

function FillInTooltip ( tipElement )
{
  var retVal = false;
// experimental
if (tipElement.getAttribute("id") == 'back-button')
  setNavButtonTooltip('back');
if (tipElement.getAttribute("id") == 'forward-button')
  setNavButtonTooltip('forward');

  var textNode = document.getElementById("TOOLTIP_tooltipText");
  if ( textNode ) {
    try {  
      var tipText = tipElement.getAttribute("tooltiptext");
      if ( tipText != "" ) {
        textNode.setAttribute('value', tipText);
        retVal = true;
      }
    }
    catch (e) { }
  }
  
  return retVal;
}
// fill HTML tooltips
function FillInHTMLTooltip ( tipElement )
{
  if (document.getElementById("menu-html-tooltips-none").getAttribute("checked") == 'true') {
     return false;
  }
  var HTMLNS = "http://www.w3.org/1999/xhtml";
  var XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
  var XLinkNS = "http://www.w3.org/1999/xlink";
  
  var retVal = false;
  var tipNode = document.getElementById("HTML_TOOLTIP_tooltipBox");
  if ( tipNode ) {
    try {
      while ( tipNode.hasChildNodes() )
        tipNode.removeChild( tipNode.firstChild );
        
      var titleText = "";
      var XLinkTitleText = "";
      var hrefText = "";
      var targetText = "";
      var imgUrlText = "";
      var imgAltText = "";
      while ( !titleText && !XLinkTitleText && tipElement ) {
        if ( tipElement.nodeType == 1 ) {
          titleText = tipElement.getAttributeNS(HTMLNS, "title");
          XLinkTitleText = tipElement.getAttributeNS(XLinkNS, "title");
    // verbose: links
    if (document.getElementById("menu-html-tooltips-verbose").getAttribute("checked") == 'true') {
      link = enclosingLink(tipElement);
      if (link) {
        hrefText = 'Link href: ' + link.href;
        if (link.target)
                targetText = 'Link TARGET: ' + link.target;
      }
      // verbose: images
      if (tipElement.tagName.toUpperCase() == 'IMG') {
              imgUrlText = 'Image URL: ' + tipElement.src;
        imgAltText = tipElement.getAttribute("alt");
        if (imgAltText)
                imgAltText = 'Image ALT: ' + imgAltText;
      }
    }
        }
        tipElement = tipElement.parentNode;
      }
      var texts = [ titleText, XLinkTitleText, hrefText, targetText, imgAltText,imgUrlText ];
      
      for (var i = 0; i < texts.length; i++) {
        var t = texts[i];
        if ( t.search(/\S/) >= 0 ) {
          var tipLineElem = tipNode.ownerDocument.createElementNS(XULNS, "text");
          tipLineElem.setAttribute("value", t);
          tipNode.appendChild(tipLineElem);
          
          retVal = true;
        }
      }
    }
    catch (e) { retVal = false; }
  }
  
  return retVal;
}
